/******************************************************************************
 *  SiteBar XUL - A Firefox sidebar for the SiteBar Bookmark Server.          *
 *  Copyright (C) 2003,2004  Bas Burger																				*
 *	<http://knowledge-emporium.com/forum/index.php?styleid=18> 					      *
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 ******************************************************************************/

var sitebar_optionsDataBoolean = new Array();
var sitebar_optionsDataInteger = new Array();
var sitebar_optionsDataString  = new Array();

// Handles changing the options page
function sitebar_changePage(pageList)
{
    sitebar_storeOptions();

    document.getElementById("sitebar-options-iframe").setAttribute("src", pageList.selectedItem.getAttribute("value"));
}


// Initializes the general page
function sitebar_initializeGeneral()
{
    const pageDocument       = document.getElementById("sitebar-options-iframe").contentDocument;
    const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    // If the open windows preference is set
    if(typeof sitebar_optionsDataBoolean["sitebar.open.windows"] != "undefined")
    {
        pageDocument.getElementById("sitebar.open.windows").checked = sitebar_optionsDataBoolean["sitebar.open.windows"];
    }
    else if(preferencesService.prefHasUserValue("sitebar.open.windows"))
    {
        pageDocument.getElementById("sitebar.open.windows").checked = preferencesService.getBoolPref("sitebar.open.windows");
    }

    // If the view source in tab preference is set
    if(typeof sitebar_optionsDataBoolean["sitebar.view.source.tab"] != "undefined")
    {
        pageDocument.getElementById("sitebar.view.source.tab").checked = sitebar_optionsDataBoolean["sitebar.view.source.tab"];
    }
    else if(preferencesService.prefHasUserValue("sitebar.view.source.tab"))
    {
        pageDocument.getElementById("sitebar.view.source.tab").checked = preferencesService.getBoolPref("sitebar.view.source.tab");
    }

		// If the sidebar host preference is set
    if(typeof sitebar_optionsDataString["sitebar.host.sidebar.address"] != "undefined")
    {
        pageDocument.getElementById("sitebar.host.sidebar.address").value = sitebar_trim(sitebar_optionsDataString["sitebar.host.sidebar.address"]);
    }
    else if(preferencesService.prefHasUserValue("sitebar.host.sidebar.address"))
    {
        pageDocument.getElementById("sitebar.host.sidebar.address").value = sitebar_trim(preferencesService.getCharPref("sitebar.host.sidebar.address"));
    }

}

// Initializes the keyboard page
function sitebar_initializeKeyboard()
{
    const pageDocument       = document.getElementById("sitebar-options-iframe").contentDocument;
    const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    // If the sidebar key is set
    if(typeof sitebar_optionsDataString["sitebar.key.sidebar"] != "undefined")
    {
        pageDocument.getElementById("sitebar.key.sidebar").value = sitebar_trim(sitebar_optionsDataString["sitebar.key.sidebar"]);
    }
    else if(preferencesService.prefHasUserValue("sitebar.key.sidebar"))
    {
        pageDocument.getElementById("sitebar.key.sidebar").value = sitebar_trim(preferencesService.getCharPref("sitebar.key.sidebar"));
    }

    // If the addpage key is set
    if(typeof sitebar_optionsDataString["sitebar.key.addpage"] != "undefined")
    {
        pageDocument.getElementById("sitebar.key.addpage").value = sitebar_trim(sitebar_optionsDataString["sitebar.key.addpage"]);
    }
    else if(preferencesService.prefHasUserValue("sitebar.key.addpage"))
    {
        pageDocument.getElementById("sitebar.key.addpage").value = sitebar_trim(preferencesService.getCharPref("sitebar.key.addpage"));
    }
}

// Initializes the sidebar page
function sitebar_initializeSidebar()
{
    const pageDocument       = document.getElementById("sitebar-options-iframe").contentDocument;
    const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    // If the sidebar width preference is set
    if(typeof sitebar_optionsDataInteger["sitebar.resize.sidebar.width"] != "undefined")
    {
        pageDocument.getElementById("sitebar.resize.sidebar.width").value = sitebar_optionsDataInteger["sitebar.resize.sidebar.width"];
    }
    else if(preferencesService.prefHasUserValue("sitebar.resize.sidebar.width"))
    {
        pageDocument.getElementById("sitebar.resize.sidebar.width").value = preferencesService.getIntPref("sitebar.resize.sidebar.width");
    }
    
}

// Initializes the sidebar page
function sitebar_initializeSitebar()
{
    const pageDocument       = document.getElementById("sitebar-options-iframe").contentDocument;
    const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    // If the open windows preference is set
    if(typeof sitebar_optionsDataBoolean["sitebar.links.sidebar.lbut"] != "undefined")
    {
        pageDocument.getElementById("sitebar.links.sidebar.lbut").checked = sitebar_optionsDataBoolean["sitebar.links.sidebar.lbut"];
    }
    else if(preferencesService.prefHasUserValue("sitebar.links.sidebar.lbut"))
    {
        pageDocument.getElementById("sitebar.links.sidebar.lbut").checked = preferencesService.getBoolPref("sitebar.links.sidebar.lbut");
    }

    // If the view source in tab preference is set
    if(typeof sitebar_optionsDataBoolean["sitebar.links.sidebar.mbut"] != "undefined")
    {
        pageDocument.getElementById("sitebar.links.sidebar.mbut").checked = sitebar_optionsDataBoolean["sitebar.links.sidebar.mbut"];
    }
    else if(preferencesService.prefHasUserValue("sitebar.links.sidebar.mbut"))
    {
        pageDocument.getElementById("sitebar.links.sidebar.mbut").checked = preferencesService.getBoolPref("sitebar.links.sidebar.mbut");
    }
    
}

// Initializes the options dialog
function sitebar_initializeOptions()
{
    const selectedPage = document.getElementById("sitebar-page-list").selectedItem.getAttribute("value");

    // If this is the general page
    if(selectedPage.indexOf("general") != -1)
    {
        sitebar_initializeGeneral();
    }
    else if(selectedPage.indexOf("keyboard") != -1)
    {
        sitebar_initializeKeyboard();
    }
    else if(selectedPage.indexOf("sidebar") != -1)
    {
        sitebar_initializeSidebar();
    }
    else if(selectedPage.indexOf("sitebar") != -1)
    {
        sitebar_initializeSitebar();
    }

}

// Saves the user's options
function sitebar_saveOptions()
{
    const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    var option      = null;
    var optionValue = null;

    // Make sure current page is stored
    sitebar_storeOptions();

    // Loop through the boolean options
    for(option in sitebar_optionsDataBoolean)
    {
        preferencesService.setBoolPref(option, sitebar_optionsDataBoolean[option]);
    }

    // Loop through the integer options
    for(option in sitebar_optionsDataInteger)
    {
        optionValue = sitebar_optionsDataInteger[option];

        // If the option value is set
        if(optionValue)
        {
            preferencesService.setIntPref(option, optionValue);
        }
        else if(preferencesService.prefHasUserValue(option))
        {
            preferencesService.clearUserPref(option);
        }
    }

    // Loop through the string options
    for(option in sitebar_optionsDataString)
    {
        optionValue = sitebar_optionsDataString[option];

        // If the option value is set or the preference currently has a value
        if(optionValue || preferencesService.prefHasUserValue(option))
        {
            preferencesService.setCharPref(option, optionValue);
        }
    }
}

// Stores the user's options to be saved later
function sitebar_storeOptions()
{
    const iFrame       = document.getElementById("sitebar-options-iframe");
    const iFrameSrc    = iFrame.getAttribute("src");
    const pageDocument = iFrame.contentDocument;

    // If this is the general page
    if(iFrameSrc.indexOf("general") != -1)
    {
        sitebar_optionsDataBoolean["sitebar.open.windows"]         = pageDocument.getElementById("sitebar.open.windows").checked;
        sitebar_optionsDataBoolean["sitebar.view.source.tab"]      = pageDocument.getElementById("sitebar.view.source.tab").checked;
        sitebar_optionsDataString["sitebar.host.sidebar.address"]  = sitebar_trim(pageDocument.getElementById("sitebar.host.sidebar.address").value);
    }
    else if(iFrameSrc.indexOf("keyboard") != -1)
    {
        
        sitebar_optionsDataString["sitebar.key.sidebar"]           = sitebar_trim(pageDocument.getElementById("sitebar.key.sidebar").value);
        sitebar_optionsDataString["sitebar.key.addpage"]           = sitebar_trim(pageDocument.getElementById("sitebar.key.addpage").value);
    }
    else if(iFrameSrc.indexOf("sidebar") != -1)
    {
        sitebar_optionsDataInteger["sitebar.resize.sidebar.width"] = pageDocument.getElementById("sitebar.resize.sidebar.width").value;
    }
    else if(iFrameSrc.indexOf("sitebar") != -1)
    {
        sitebar_optionsDataBoolean["sitebar.links.sidebar.lbut"]   = pageDocument.getElementById("sitebar.links.sidebar.lbut").checked;
        sitebar_optionsDataBoolean["sitebar.links.sidebar.mbut"]   = pageDocument.getElementById("sitebar.links.sidebar.mbut").checked;
    }

}
